unit U_ShaRKInPut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit,
  ComCtrls, ToolWin, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxControls, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient, cxButtonEdit,
  cxTextEdit;

type
  TfrmShaRKInPut = class(TForm)
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column2: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    v1Column4: TcxGridDBColumn;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    v1Column12: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column18: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column14PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column1PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column5PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column11PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column16PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column13PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure v1Column10PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column18PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    { Private declarations }
    function SaveCKData():Boolean;
  public
    { Public declarations }
    FBCId,canshu3:String;

  end;

var
  frmShaRKInPut: TfrmShaRKInPut;

implementation
uses
  U_DataLink,U_RTFun,U_ClothContractListHZCX,U_ZDYHelp, U_ZdyAttachGYS,U_BPShengChanListSel,
  U_ZdyAttachCP,U_ContractCGJGSelList;

{$R *.dfm}

procedure TfrmShaRKInPut.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmShaRKInPut.TBAddClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty=False then
  begin
    CopyAddRowCDS(CDS_Sub);
    with CDS_Sub do
    begin
      Edit;
      FieldByName('SPID').Value:=null;
      post;
    end;
  end else
  begin
    with CDS_Sub do
    begin
      Append;
      FieldByName('CRTime').Value:=Trim(FormatDateTime('yyyy-MM-dd',Now));
      FieldByName('QtyUnit').Value:='Kg';
      Post;
    end;
  end;

end;
function TfrmShaRKInPut.SaveCKData():Boolean;
var
  FCRID,Maxno,FFSPID:string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
          open;
        end;
        FFSPID:=Trim(ADOQueryTemp.fieldbyname('SPID').AsString);
        if Trim(FFSPID)='' then
        begin
          if GetLSNo(ADOQueryCmd,Maxno,'SR','CK_SXPB_CR',3,1)=False then
          begin
            Result:=False;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('取纱线入库编号失败!','提示',0);
            Exit;
          end;
        end else
        begin
          Maxno:=Trim(FFSPID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(Maxno)+'''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(FFSPID)='' then
          begin
            Append;
          end else
          begin
            Edit;
          end;
          FieldByName('SPID').Value:=Trim(Maxno);
          FieldByName('FZSPID').Value:=Trim(Maxno);
          FieldByName('CKName').Value:='纱线';
          FieldByName('FactoryNo').Value:=Trim(CDS_Sub.fieldbyname('FactoryNo').AsString);
          FieldByName('FromFactoryNo').Value:=Trim(CDS_Sub.fieldbyname('FromFactoryNo').AsString);
          FieldByName('ToFactoryNo').Value:=Trim(CDS_Sub.fieldbyname('ToFactoryNo').AsString);
          FieldByName('SCMainIdRK').Value:=Trim(CDS_Sub.fieldbyname('SCMainIdRK').AsString);
          FieldByName('SCSubIdRK').Value:=Trim(CDS_Sub.fieldbyname('SCSubIdRK').AsString);
          FieldByName('CGMainId').Value:=Trim(CDS_Sub.fieldbyname('CGMainId').AsString);
          FieldByName('CGSubId').Value:=Trim(CDS_Sub.fieldbyname('CGSubId').AsString);
          FieldByName('CPID').Value:=Trim(CDS_Sub.fieldbyname('CPID').AsString);
          FieldByName('CRFlag').Value:='入库';
          FieldByName('CRQtyFlag').Value:=1;
          RTSetSaveDataCDS(ADOQueryCmd,Tv1,CDS_Sub,'CK_SXPB_CR',2);
          if Trim(FFSPID)='' then
            FieldByName('Filler').Value:=Trim(DName)
          else
          begin
            FieldByName('Editer').Value:=Trim(DName);
            FieldByName('EditTime').Value:=SGetServerDate(ADOQueryTemp);
          end;
          if Trim(CDS_Sub.fieldbyname('SCOrderNo').AsString)<>'' then
          begin
            FieldByName('QCSCOrderNo').Value:=Trim(CDS_Sub.fieldbyname('SCOrderNo').AsString);
          end;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(' where SPID='''+Trim(Maxno)+'''');
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(Maxno)+'''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('MXKCQty').Value<0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('入库数小于出库数不能保存!','提示',0);
          Exit;
        end;
        Edit;
        FieldByName('SPID').Value:=Trim(Maxno);
        //FieldByName('CRID').Value:=Trim(FCRID);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=False;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('保存异常!','提示',0);
  end;
end;

procedure TfrmShaRKInPut.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('纱线入库登记11',Tv1,'纱线仓库');
  Close;
end;

procedure TfrmShaRKInPut.FormShow(Sender: TObject);
var
  fsj:String;
begin
  ReadCxGrid('纱线入库登记11',Tv1,'纱线仓库');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(',SCOrderNO=(select OrderNO from Cloth_Main JM where JM.MainId=A.SCMainIdRK)');
    sql.Add(',ConNo=(select ConNo from Contract_Main JM where JM.MainId=A.CGMainId)');
    sql.Add(' from CK_SXPB_CR A');
    sql.Add(' where SPID='''+Trim(FBCId)+'''');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp,CDS_Sub);
  SInitCDSData20(ADOQueryTemp,CDS_Sub);
  if CDS_Sub.IsEmpty then Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from CK_SXPB_CR where FZSPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
    sql.Add(' and CRQtyFlag=-1');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    v1Column4.Options.Focusing:=False;
    
    //v1Column13.Options.Focusing:=False;
    v1Column14.Options.Focusing:=False;
    v2Column1.Options.Focusing:=False;
    v1Column8.Options.Focusing:=False;
    v1Column7.Options.Focusing:=False;
    //v1Column1.Options.Focusing:=False;
    //v1Column10.Options.Focusing:=False;
    v1Column11.Options.Focusing:=False;
    Exit;
  end else
  begin
    v1Column4.Options.Focusing:=True;
    
    v1Column13.Options.Focusing:=True;
    v1Column14.Options.Focusing:=True;
    v2Column1.Options.Focusing:=True;
    v1Column8.Options.Focusing:=True;
    v1Column7.Options.Focusing:=True;
    //v1Column1.Options.Focusing:=True;
    //v1Column10.Options.Focusing:=True;
    v1Column11.Options.Focusing:=True;
  end;
end;

procedure TfrmShaRKInPut.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  if Trim(CDS_Sub.fieldbyname('SPID').AsString)<>'' then
  begin
    if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where FZSPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
      sql.Add(' and CRQtyFlag=-1');
      Open;
    end;
    if ADOQueryTemp.IsEmpty=False then
    begin
      Application.MessageBox('已有出库记录，不能删除!','提示',0);
      Exit;
    end;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
        ExecSQL;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!','提示',0);
    end;

  end else
  begin
    CDS_Sub.Delete;
  end;

end;

procedure TfrmShaRKInPut.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  if CDS_Sub.Locate('CRTime',null,[])=True then
  begin
    Application.MessageBox('入库时间不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('CRType',null,[])=True then
  begin
    Application.MessageBox('入库类型不能为空!','提示',0);
    Exit;
  end;
  {if CDS_Sub.Locate('SSType',null,[])=True then
  begin
    Application.MessageBox('所属类型不能为空!','提示',0);
    Exit;
  end;  }
  if CDS_Sub.Locate('SPName',null,[])=True then
  begin
    Application.MessageBox('品名不能为空!','提示',0);
    Exit;
  end;
  {if CDS_Sub.Locate('SPCF',null,[])=True then
  begin
    Application.MessageBox('成分不能为空!','提示',0);
    Exit;
  end;  }
  if CDS_Sub.Locate('CRType;FromFactoryName',VarArrayOf(['染纱加工退回',Null]),[loPartialKey])=True then
  begin
    Application.MessageBox('染纱加工退回的数据，来自工厂不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('CRType;FromFactoryName',VarArrayOf(['网络加工退回',Null]),[loPartialKey])=True then
  begin
    Application.MessageBox('网络加工退回的数据，来自工厂不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('CRType;FromFactoryName',VarArrayOf(['织造加工退回',Null]),[loPartialKey])=True then
  begin
    Application.MessageBox('织造加工退回的数据，来自工厂不能为空!','提示',0);
    Exit;
  end;
  {if CDS_Sub.Locate('CRType;ConNo',VarArrayOf(['采购入库',Null]),[loPartialKey])=True then
  begin
    Application.MessageBox('采购入库的数据，采购合同号不能为空!','提示',0);
    Exit;
  end;  }
  if CDS_Sub.Locate('ToFactoryName',null,[])=True then
  begin
    Application.MessageBox('存放工厂不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('FactoryName',null,[])=True then
  begin
    Application.MessageBox('供应商不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('PiQty',null,[])=True then
  begin
    Application.MessageBox('箱/件数不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('Qty',null,[])=True then
  begin
    Application.MessageBox('数量不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('QtyUnit',null,[])=True then
  begin
    Application.MessageBox('数量单位不能为空!','提示',0);
    Exit;
  end;

  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!','提示',0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmShaRKInPut.v1Column3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='SXKuWei';
      flagname:='库位';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmShaRKInPut.v1Column14PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('FactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('FactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;

end;

procedure TfrmShaRKInPut.v2Column1PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  if Trim(canshu3)='' then
  begin
    try
      frmZDYHelp:=TfrmZDYHelp.Create(Application);
      with frmZDYHelp do
      begin
        flag:='SXYCLName';
        flagname:='纱线名称';
        if ShowModal=1 then
        begin
          with Self.CDS_Sub do
          begin
            Edit;
            FieldByName('SPName').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
          end;
        end;
      end;
    finally
      frmZDYHelp.Free;
    end;
  end else
  begin
    try
      frmZdyAttachCP:=TfrmZdyAttachCP.Create(Application);
      with frmZdyAttachCP do
      begin
        if ShowModal=1 then
        begin
          with Self.CDS_Sub do
          begin
            Edit;
            FieldByName('SPName').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('ZdyName').AsString);
            FieldByName('SPSpec').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('DEFstr1').AsString);
            FieldByName('SPCF').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('DEFstr2').AsString);
            FieldByName('SPMF').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('DEFstr7').AsString);
            FieldByName('SPKZ').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('DEFstr8').AsString);
            FieldByName('SPKZ').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('DEFstr8').AsString);
            FieldByName('SPCode').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('ZdyCode').AsString);
            FieldByName('CPID').Value:=Trim(frmZdyAttachCP.CDS_HZ.fieldbyname('ATID').AsString);
          end;
        end;
      end;
    finally
      frmZdyAttachCP.Free;
    end;
  end;

end;

procedure TfrmShaRKInPut.v1Column5PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='KuWei';
      flagname:='库位';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmShaRKInPut.v1Column11PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('ToFactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('ToFactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmShaRKInPut.v1Column16PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('FromFactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('FromFactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmShaRKInPut.v1Column13PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmBPShengChanListSel:=TfrmBPShengChanListSel.Create(Application);
    with frmBPShengChanListSel do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('SCMainIdRK').Value:=Trim(frmBPShengChanListSel.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('SCSubIdRK').Value:=Trim(frmBPShengChanListSel.Order_Main.fieldbyname('SubId').AsString);
          FieldByName('SCOrderNo').Value:=Trim(frmBPShengChanListSel.Order_Main.fieldbyname('ConNo').AsString);
        end;
      end;
    end;
  finally
    frmBPShengChanListSel.Free;
  end;
end;

procedure TfrmShaRKInPut.Tv1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if CDS_Sub.IsEmpty then Exit;
  if Trim(canshu3)='' then exit;
  v1Column8.Options.Editing:=False;
  v1Column7.Options.Editing:=False;
  (v2Column1.Properties as TcxButtonEditProperties).ReadOnly:=True;
end;

procedure TfrmShaRKInPut.v1Column10PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='GSTT';
      flagname:='公司抬头';
      frmZDYHelp.TBAdd.Visible:=False;
      frmZDYHelp.TBDel.Visible:=False;
      frmZDYHelp.TBEdit.Visible:=False;
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ComTaiTou').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmShaRKInPut.v1Column18PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmContractCGJGSelList:=TfrmContractCGJGSelList.Create(Application);
    with frmContractCGJGSelList do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ConNo').Value:=frmContractCGJGSelList.Order_Main.fieldbyname('ConNo').Value;
          FieldByName('CGMainId').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('CGSubId').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('SubId').AsString);
          FieldByName('FactoryName').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('FactoryNoName').AsString);
          FieldByName('FactoryNo').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('FactoryNo').AsString);
          FieldByName('SPName').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('C_CodeName').AsString);
          FieldByName('SPSpec').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('C_Spec').AsString);
          FieldByName('SPCF').Value:=Trim(frmContractCGJGSelList.Order_Main.fieldbyname('C_CF').AsString);
        end;
      end;
    end;
  finally
    frmContractCGJGSelList.Free;
  end;
end;

end.
